*;
*;------------------------------------------------------------------
*; FLOAT SUBROUTINE--convert 2's comp number to floating
*;		  INPUT: accumulator
*;		  OUTPUT:
*;			--4b exponent left in accum
*;			--6b mantissa left in TEMP1
*;			--sign preserved in original number
*;
*;------------------------------------------------------------------
*;
FLOAT	SACH	TEMP1
	LAC	TEMP1
	ABS
	SACL	TEMP1
	SUB	ONE,6	; binary search to get expONEnt
	BGEZ	E7TOD
E0TO7	ADD	K56	; TEMP1-8 -- exp = 0-6
	BGEZ	E4TO6
E0TO3	ADD	THREE,1 ; TEMP1-2 -- exp = 0-3
	BGEZ	E2TO3
E0TO1	LAC	TEMP1	; exp = 0-1
	BNZ	E1
E0	LAC	ONE,5	; exp=0
	SACL	TEMP1
	LACK	FLTSFT+0
	RET
E1	LAC	TEMP1,5 ; exp=1
	SACL	TEMP1
	LACK	FLTSFT+1
	RET
E2TO3	SUB	ONE,1	; TEMP1-4 -- exp = 2-3
	BGEZ	E3
E2	LAC	TEMP1,4 ; exp=2
	SACL	TEMP1
	LACK	FLTSFT+2
	RET
E3	LAC	TEMP1,3 ; exp=3
	SACL	TEMP1
	LACK	FLTSFT+3
	RET
E4TO6	SUB	ONE,3	; TEMP1-16 -- exp = 4-6
	BGEZ	E5TO6
E4	LAC	TEMP1,2 ; exp=4
	SACL	TEMP1
	LACK	FLTSFT+4
	RET
E5TO6	SUB	ONE,4	; TEMP1-32 -- exp = 5-6
	BGEZ	E6
E5	LAC	TEMP1,1 ; exp=5
	SACL	TEMP1
	LACK	FLTSFT+5
	RET
E6	LACK	FLTSFT+6	; exp=6
	RET
E7TOD	SUB	M15,6	; TEMP1-1024 -- exp = 7-13
	BGEZ	EBTOD
E7TOA	ADD	THREE,8 ; TEMP1-256  -- exp = 7-10
	BGEZ	E9TOA
E7TO8	ADD	ONE,7	; TEMP1-128  -- exp = 7-8
	BGEZ	E8
E7	LAC	TEMP1,15 ; exp=7
	SACH	TEMP1
	LACK	FLTSFT+7
	RET
E8	LAC	TEMP1,14 ; exp=8
	SACH	TEMP1
	LACK	FLTSFT+8
	RET
E9TOA	SUB	ONE,8	; TEMP1-512  -- exp = 9-10
	BGEZ	E10
E9	LAC	TEMP1,13 ; exp=9
	SACH	TEMP1
	LACK	FLTSFT+9
	RET
E10	LAC	TEMP1,12 ; exp=10
	SACH	TEMP1
	LACK	FLTSFT+10
	RET
EBTOD	SUB	THREE,10	; TEMP1-4096 -- exp=11-13
	BGEZ	EDTOE
EBTOC	ADD	ONE,11	; TEMP1-2048 -- exp=11-12
	BGEZ	E12
E11	LAC	TEMP1,11 ; exp=11
	SACH	TEMP1
	LACK	FLTSFT+11
	RET
E12	LAC	TEMP1,10 ; exp=12
	SACH	TEMP1
	LACK	FLTSFT+12
	RET
EDTOE	SUB	ONE,12	; TEMP1-8192 -- exp=0
	BGEZ	E0
E13	LAC	TEMP1,9  ; exp=13
	SACH	TEMP1
	LACK	FLTSFT+13
	RET
	.page
